<%
'******************************************************************
' Classe ImageSize
'   Data una immagine restituisce le dimensioni X,Y e numero di
'   colori
'
'     ImageFile = path fisico completo dell'immagine
'     ImageName = restituisce il nome del file
'     ImageType = restituisce il tipo di immagine
'     ImageWidth = restituisce la larghezza in pixel dell'immagine
'     ImageHeight = restituisce l'altezza in pixel dell'immagine
'     ImageDepth = restituisce il numero di colori dell'immagine
'     IsImage = restituisce TRUE se il file  una immagine
'
' Author:
' 2002 Luciani Massimiliano
' http://www.byluciani.com
' webmaster@byluciani.com
'
' Original code:
' http://www.4guysfromrolla.com/webtech/011201-1.shtml
' Author: Mike Shaffer - mshaffer@nkn.net
'
' This script is FREEWARE
'
' Adapted for the ASP Connector by Grant French (grant@mcpuk.net)
'******************************************************************
 

 
  Function GetBytes(flnm, offset, bytes)
    Dim objFSO
    Dim objFTemp
    Dim objTextStream
    Dim lngSize

    on error resume next

    Set objFSO = CreateObject("Scripting.FileSystemObject")

    ' First, we get the filesize
    Set objFTemp = objFSO.GetFile(flnm)
    lngSize = objFTemp.Size
    set objFTemp = nothing
    
    fsoForReading = 1
    Set objTextStream = objFSO.OpenTextFile(flnm, fsoForReading)
    
    if offset > 0 then
      strBuff = objTextStream.Read(offset - 1)
    end if
    
    if bytes = -1 then	' Get All!
      GetBytes = objTextStream.Read(lngSize)  'ReadAll
    else
      GetBytes = objTextStream.Read(bytes)
    end if

    objTextStream.Close
    set objTextStream = nothing
    set objFSO = nothing
  end function
 
  function lngConvert(strTemp)
    lngConvert=clng(asc(left(strTemp,1))+((asc(right(strTemp,1))*256)))
  end function
 
  function lngConvert2(strTemp)
    lngConvert2=clng(asc(right(strTemp,1))+((asc(left(strTemp,1))*256)))
  end function
  
  Function gfxSpex(flnm)

    dim strPNG 
    dim strGIF
    dim strBMP
    dim strType
    strType = ""
    strImageType = "(unknown)"

    bolIsImage = False

    strPNG = chr(137) & chr(80) & chr(78)
    strGIF = "GIF"
    strBMP = chr(66) & chr(77)

    strType = GetBytes(flnm, 0, 3)
	'Response.Write strType
	
    if strType = strGIF then				' is GIF

      strImageType = "GIF"
      lngWidth = lngConvert(GetBytes(flnm, 7, 2))
      lngHeight = lngConvert(GetBytes(flnm, 9, 2))
      lngDepth = 2 ^ ((asc(GetBytes(flnm, 11, 1)) and 7) + 1)
      bolIsImage = True

    elseif left(strType, 2) = strBMP then		' is BMP

      strImageType = "BMP"
      lngWidth = lngConvert(GetBytes(flnm, 19, 2))
      lngHeight = lngConvert(GetBytes(flnm, 23, 2))
      lngDepth = 2 ^ (asc(GetBytes(flnm, 29, 1)))
      bolIsImage = True

    elseif strType = strPNG then			' Is PNG

      strImageType = "PNG"
      lngWidth = lngConvert2(GetBytes(flnm, 19, 2))
      lngHeight = lngConvert2(GetBytes(flnm, 23, 2))
      lngDepth = getBytes(flnm, 25, 2)

      select case asc(right(lngDepth,1))
        case 0
          lngDepth = 2 ^ (asc(left(lngDepth, 1)))
          bolIsImage = True
        case 2
          lngDepth = 2 ^ (asc(left(lngDepth, 1)) * 3)
          bolIsImage = True
        case 3
          lngDepth = 2 ^ (asc(left(lngDepth, 1)))  '8
          bolIsImage = True
        case 4
          lngDepth = 2 ^ (asc(left(lngDepth, 1)) * 2)
          bolIsImage = True
        case 6
          lngDepth = 2 ^ (asc(left(lngDepth, 1)) * 4)
          bolIsImage = True
        case else
          lngDepth = -1
      end select

    else

      strBuff = GetBytes(flnm, 0, -1)	' Get all bytes from file
      lngSize = len(strBuff)
      flgFound = 0

      strTarget = chr(255) & chr(216) & chr(255)
      flgFound = instr(strBuff, strTarget)
 
		gfxSpex=strImageType
      if flgFound = 0 then exit function
    end if

    strImageType = "JPG"
  
  gfxSpex=strImageType
  
end function
 
  Function doName(strPath)
    Dim arrSplit
    arrSplit = Split(strPath, "\")
    doName = arrSplit(UBound(arrSplit))
  End Function
  
%>