<?
/* FCK Editor 2, PHP Integration Pack
 * Written by Grant French (grant@eforeducation.co.uk)
 * Date: October 2004
 *
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * http://www.fckeditor.net
 *
 */

class FCKeditor {

	var $instanceName;
	var $pagedata;
	var $width;
	var $height;
	var $config;
	var $basePath;
	var $toolbar;
	
	function checkVarName($varname) {
		$allowed=array();
		
		//numbers allowed
		for ($i=48;$i<58;$i++) array_push($allowed,chr($i));
		
		//lowercase letters allowed
		for ($i=65;$i<91;$i++) array_push($allowed,chr($i));
		
		//uppercase letters allowed
		for ($i=97;$i<123;$i++) array_push($allowed,chr($i));
		
		//allow underscore
		array_push($allowed,'_');
		
		//Replace all allowed chars
		$n_varname=str_replace($allowed,"",$varname);
		
		//If the name is valid the length of the varname
		//	minus all allowed chars should be 0
		if (strlen($n_varname)==0) {
			$firstchar=ord(substr($varname,0,1));
			if (($firstchar>47)&&($firstchar<58)) {
				//Starts with a number
				return false;
			} else {
				//All ok.
				return true;
			}
		} else { 
			//Contains invalid chars
			return false; 
		}
	}
	
	function FCKeditor($instanceName) {
		if ($this->checkVarName($instanceName)) {
			$this->instanceName=$instanceName;
		} else {
			$this->instanceName="InvalidNamePassed";
		}
	
		$this->config=array();
		$this->SetWidth("90%");
		$this->SetHeight("300px");
		$this->SetBasePath(dirname($_SERVER['SCRIPT_NAME']));
		$this->SetToolbarSet("Default");
	}
	
	
	function GetInstanceName() { return $this->instanceName; }
	function SetInstanceName($newName) { 
		if ($this->checkVarName($newName)) {
			$this->instanceName=$newName;
			return true;
		} else {
			return false;
		}
	}
		
	function GetWidth() { return $this->width; }
	function SetWidth($width) { $this->width=$width; }

	function GetHeight() { return $this->height; }
 	function SetHeight($height) { $this->height=$height; }	

	function GetValue() { return (!isset($this->pagedata)?(isset($_POST[$this->instanceName])?$_POST[$this->instanceName]:''):$this->pagedata); }
	function SetValue($data) { $this->pagedata=htmlspecialchars($data); }

	function GetBasePath() { return $this->basePath; }
	function SetBasePath($newpath) { $this->basePath=str_replace("//","/",($newpath."/")); }
	
	function GetToolbarSet() { return $this->toolbar; }
	function SetToolbarSet($toolbar) { $this->toolbar=$toolbar; }
	
	function GetConfig($key) { return $this->config[$key]; }
	function SetConfig($key,$value) { $this->config[$key]=$value; }
		
	function Create() {
		
		if ($this->instanceName=="InvalidNamePassed") {
				?>
				<div style="font-weight: bold; font-size: large;">
					Invalid instance name passed
				</div>
				<?php
				return;
		}
		
		if (!$this->IsCompatible()) { 
			?>
			<div style="font-weight: bold; font-size: large;">
				Your browser is not capable of displaying this editor. <br />
				Please upgrade or switch browsers. <br />
				(IE 5.5+ or a recent version of Mozilla/Firefox/Netscape required)
			</div>
			<div class="fckeditor">
				<textarea name="<?php echo $this->instanceName; ?>" rows="4" cols="40" style="width: <?php echo $this->width; ?>; height: <?php echo $this->height; ?>" wrap="virtual"><?php echo $this->pagedata; ?></textarea>
			</div>
			<?php
			
		} else {
			?>
			<div class="fckeditor">
				<input type="hidden" id="<?php echo $this->instanceName; ?>" name="<?php echo $this->instanceName; ?>" value="<?php echo $this->pagedata; ?>">
				<input type="hidden" id="<?php echo $this->instanceName; ?>___Config" value="<?php echo $this->http_build_query($this->config); ?>">
				<iframe id="<?php echo $this->instanceName; ?>___Frame" src="<?php echo $this->basePath; ?>editor/fckeditor.html?InstanceName=<?php echo $this->instanceName; ?>&Toolbar=<?php echo $this->toolbar; ?>" width="<?php echo $this->width; ?>" height="<?php echo $this->height; ?>" frameborder="no" scrolling="no"></iframe>
			</div>
			<?php
		}
	}
	
	function IsCompatible()
	{
		$sAgent = $_SERVER['HTTP_USER_AGENT'] ;
		if ( is_integer( strpos($sAgent, 'MSIE') ) && is_integer( strpos($sAgent, 'Windows') ) && !is_integer( strpos($sAgent, 'Opera') ) )
		{
			$iVersion = floatval( substr( $sAgent, strpos( $sAgent, 'MSIE' ) + 5, 3) ) ;
			return ( $iVersion >= floatval( 5.5 ) ) ;
		}
		elseif ( is_integer( strpos($sAgent, 'Gecko/') ) )
		{
			$iVersion = intval( substr( $sAgent, strpos( $sAgent, 'Gecko/' ) + 6, 8) ) ;
			return ( $iVersion >= intval( 20030210 ) ) ;
		}
		else
			return false;
	}
	
	function http_build_query( &$a, $pref = '', $f = '', $idx = '')
	{//Altered code from a help article at http://us3.php.net/function.http-build-query
		$ret = '';
		foreach ( $a as $i => $j )
		{
			if ( $idx != '' )
				$i = $idx."[$i]";
			if ( is_array( $j ) )
				$ret .= $this->http_build_query( $j, '', $f, $i );
			else
			{
				$j = urlencode( $j );
				if ( is_int( $i ) )
					$ret .= "$f$pref$i=$j";
				else
					$ret .= "$f$i=$j";
			}
			$f = '&';
		}
		return $ret;
	}
}
?>
