/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003 Frederico Caldeira Knabben
 *
 * Licensed under the terms of the GNU Lesser General Public License
 * (http://www.opensource.org/licenses/lgpl-license.php)
 *
 * For further information go to http://www.fredck.com/FCKeditor/ 
 * or contact fckeditor@fredck.com.
 *
 * fck_toolbaritems.js: Defines all the available toolbar items.
 *
 * Authors:
 *   Frederico Caldeira Knabben (fckeditor@fredck.com)
 */

// This class holds the available toolbar items definitions
function TBI() {}

// Standard
TBI.prototype.Cut			= new TBButton("Cut"			, "Cut"						, DECMD_CUT) ;
TBI.prototype.Copy			= new TBButton("Copy"			, "Copy"					, DECMD_COPY) ;
TBI.prototype.Paste			= new TBButton("Paste"			, "Paste"					, DECMD_PASTE) ;
TBI.prototype.PasteText		= new TBButton("PasteText"		, "Paste as plain text"		, "pastePlainText()"		, TBCMD_CUSTOM, "checkDecCommand(DECMD_PASTE)") ;
TBI.prototype.PasteWord		= new TBButton("PasteWord"		, "Paste from Word"			, "pasteFromWord()"			, TBCMD_CUSTOM, "checkDecCommand(DECMD_PASTE)") ;
TBI.prototype.Find			= new TBButton("Find"			, "Find"					, DECMD_FINDTEXT) ;
TBI.prototype.SelectAll		= new TBButton("SelectAll"		, "Select All"				, DECMD_SELECTALL) ;
TBI.prototype.RemoveFormat	= new TBButton("RemoveFormat"	, "Remove Format"			, DECMD_REMOVEFORMAT) ;
TBI.prototype.Link			= new TBButton("Link"			, "Insert/Edit Link"		, "dialogLink()"			, TBCMD_CUSTOM, "checkDecCommand(DECMD_HYPERLINK)") ;
TBI.prototype.RemoveLink	= new TBButton("Unlink"			, "Remove Link"				, DECMD_UNLINK) ;
TBI.prototype.Image			= new TBButton("Image"			, "Insert/Edit Image"		, "dialogImage()"			, TBCMD_CUSTOM) ;
TBI.prototype.Table			= new TBButton("Table"			, "Insert/Edit Table"		, "dialogTable()"			, TBCMD_CUSTOM) ;
TBI.prototype.Rule			= new TBButton("Rule"			, "Insert Horizontal Line"	, "InsertHorizontalRule"	, TBCMD_DOC) ;
TBI.prototype.SpecialChar	= new TBButton("SpecialChar"	, "Insert Special Character", "insertSpecialChar()"		, TBCMD_CUSTOM) ;
TBI.prototype.Smiley		= new TBButton("Smiley"			, "Insert Smiley"			, "insertSmiley()"			, TBCMD_CUSTOM) ;
TBI.prototype.About			= new TBButton("About"			, "About Richtext Editor"	, "about()"					, TBCMD_CUSTOM) ;

// Formatting
TBI.prototype.Bold			= new TBButton("Bold"			, "Bold"					, DECMD_BOLD) ;
TBI.prototype.Italic		= new TBButton("Italic"			, "Italic"					, DECMD_ITALIC) ;
TBI.prototype.Underline		= new TBButton("Underline"		, "Underline"				, DECMD_UNDERLINE) ;
TBI.prototype.StrikeThrough	= new TBButton("StrikeThrough"	, "Strike Through"			, "strikethrough"		, TBCMD_DOC) ;
TBI.prototype.Subscript		= new TBButton("Subscript"		, "Subscript"				, "subscript"			, TBCMD_DOC) ;
TBI.prototype.Superscript	= new TBButton("Superscript"	, "Superscript"				, "superscript"			, TBCMD_DOC) ;
TBI.prototype.JustifyLeft	= new TBButton("JustifyLeft"	, "Left Justify"			, DECMD_JUSTIFYLEFT) ;
TBI.prototype.JustifyCenter	= new TBButton("JustifyCenter"	, "Center Justify"			, DECMD_JUSTIFYCENTER) ;
TBI.prototype.JustifyRight	= new TBButton("JustifyRight"	, "Right Justify"			, DECMD_JUSTIFYRIGHT) ;
TBI.prototype.JustifyFull	= new TBButton("JustifyFull"	, "Block Justify"			, "JustifyFull"			, TBCMD_DOC) ;
TBI.prototype.Outdent		= new TBButton("Outdent"		, "Decrease Indent"			, DECMD_OUTDENT) ;
TBI.prototype.Indent		= new TBButton("Indent"			, "Increase Indent"			, DECMD_INDENT) ;
TBI.prototype.Undo			= new TBButton("Undo"			, "Undo"					, DECMD_UNDO) ;
TBI.prototype.Redo			= new TBButton("Redo"			, "Redo"					, DECMD_REDO) ;
TBI.prototype.InsertOrderedList		= new TBButton("InsertOrderedList"	, "Numbered List", DECMD_ORDERLIST) ;
TBI.prototype.InsertUnorderedList	= new TBButton("InsertUnorderedList", "Buletted List", DECMD_UNORDERLIST) ;

// Options
TBI.prototype.ShowTableBorders	= new TBButton("ShowTableBorders", "Show Table Borders", "showTableBorders()", TBCMD_CUSTOM, "checkShowTableBorders()") ;
TBI.prototype.ShowDetails		= new TBButton("ShowDetails", "Show Details", "showDetails()", TBCMD_CUSTOM, "checkShowDetails()") ;

// Font
TBI.prototype.FontStyle		= new TBCombo( "FontStyle"		, "doStyle(this)"			, "Style"	, config.StyleNames, config.StyleValues, 'CheckStyle("cmbFontStyle")') ;
TBI.prototype.FontFormat	= new TBCombo( "FontFormat"		, "doFormatBlock(this)"		, "Format"	, config.BlockFormatNames, config.BlockFormatNames, 'CheckFontFormat("cmbFontFormat")') ;
TBI.prototype.Font			= new TBCombo( "Font"			, "doFontName(this)"		, "Font"	, config.ToolbarFontNames, config.ToolbarFontNames, 'CheckFontName("cmbFont")') ;
TBI.prototype.FontSize		= new TBCombo( "FontSize"		, "doFontSize(this)"		, "Size"	, ';xx-small;x-small;small;medium;large;x-large;xx-large', ';1;2;3;4;5;6;7', 'CheckFontSize("cmbFontSize")') ;
TBI.prototype.TextColor		= new TBButton("TextColor"		, "Text Color"				, "foreColor()"	, TBCMD_CUSTOM) ;
TBI.prototype.BGColor		= new TBButton("BGColor"		, "Background Color"		, "backColor()"	, TBCMD_CUSTOM) ;
TBI.prototype.EditSource	= new TBCheckBox("EditSource"	, "switchEditMode()"		, "Source", "onViewMode") ;

// This is the object that holds the available toolbar items
var oTB_Items = new TBI() ;